#include <stdio.h>
#ifdef __ARC64__
# include <unistd.h>
#endif

#if defined __LCC__ && __LCC__ < 124
typedef struct {
	unsigned long long lo;
	unsigned long long hi;
} __uint128_t;
#endif

#ifdef __amd64__
# define ATTRIB __attribute__((sysv_abi))
#else
# define ATTRIB
#endif

__uint128_t str2ulll(unsigned char *, char **, int);
__uint128_t ATTRIB bitr128(__uint128_t);

int main()
{
	char s[BUFSIZ];
	__uint128_t n;

	setvbuf(stdin, NULL, _IONBF, 0);
	setvbuf(stdout, NULL, _IONBF, 0);
	n = str2ulll((unsigned char *)fgets(s, sizeof(s), stdin), NULL, 16);
	n = bitr128(n);
#if defined __LCC__ && __LCC__ < 124
	printf("%016llX%016llX\n", n.hi, n.lo);
#else
	printf("%016llX%016llX\n", (unsigned long long)(n >> 64), (unsigned long long)n);
#endif

#ifdef __ARC64__
	_exit(0);
#else
	return 0;
#endif
}
