#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#ifdef __ARC64__
# include <unistd.h>
#endif

ssize_t getrandom(void *, size_t, unsigned);

#ifdef __amd64__
# define ATTRIB __attribute__((sysv_abi))
#else
# define ATTRIB
#endif

void ATTRIB putipstr(unsigned, char *);

int main()
{
	char s[16];
	unsigned ip;

#if defined __APPLE__ || defined __OpenBSD__
        arc4random_buf(&ip, sizeof(ip));
#else
	getrandom(&ip, sizeof(ip), 0);
#endif
	putipstr(ip, s);
	setvbuf(stdout, NULL, _IONBF, 0);
	printf("%08X -> %s\n", ip, s);
#ifdef __ARC64__
	_exit(0);
#else
	return 0;
#endif
}
