const int N = sizeof(unsigned) * 8;

#include <iostream>
#include <bitset>

using namespace std;

bitset<N> rot(bitset<N> val, int n)
{
	return n > 0 ? val << n | val >> (N - n)
		    : val >> -n | val << ((N + n) & (N - 1));
}


int main()
{
	bitset<N> b;
	cin >> b;
	cout << endl;
	for (int i = 0; i < N; i++) {
		bitset<N> b1(rot(b, i)), b2(rot(b, -i));
		cout << b1 << "\t" << b2 << endl;
	}
	return 0;
}
