#include <stdio.h>
#ifdef __ARC64__
# include <unistd.h>
#endif

#ifdef __amd64__
# define ATTRIB __attribute__((sysv_abi))
#else
# define ATTRIB
#endif

unsigned ATTRIB getipstr(char *);

int main(int argc, char *argv[])
{
	setvbuf(stdout, NULL, _IONBF, 0);
	if (argc != 2) {
		printf("Usage: %s <dotted-address>\n", argv[0]);
#ifdef __ARC64__
		_exit(-1);
#else
		return -1;
#endif
	}
	printf("%08X\n", getipstr(argv[1]));
#ifdef __ARC64__
	_exit(0);
#else
	return 0;
#endif
}
