#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#ifdef __ARC64__
# include <unistd.h>
#endif

ssize_t getrandom(void *, size_t, unsigned);

#ifdef __amd64__
# define ATTRIB __attribute__((sysv_abi))
#else
# define ATTRIB
#endif

void ATTRIB putmacst(unsigned long long, char *);

int main()
{
	char s[18];
	unsigned long long mac;

#if defined __APPLE__ || defined __OpenBSD__
        arc4random_buf(&mac, sizeof(mac));
#else
	getrandom(&mac, sizeof(mac), 0);
#endif
	mac &= 0xFFFFFFFFFFFF;
	putmacst(mac, s);
	setvbuf(stdout, NULL, _IONBF, 0);
	printf("%012llX -> %s\n", mac, s);
#ifdef __ARC64__
	_exit(0);
#else
	return 0;
#endif
}
